--- board/raspberrypi/rpi/rpi.c.orig	2017-09-11 11:10:40.000000000 -0700
+++ board/raspberrypi/rpi/rpi.c	2018-02-10 17:31:02.604866000 -0800
@@ -14,6 +14,7 @@
 #include <lcd.h>
 #include <memalign.h>
 #include <mmc.h>
+#include <asm/system.h>
 #include <asm/gpio.h>
 #include <asm/arch/mbox.h>
 #include <asm/arch/msg.h>
@@ -30,6 +31,8 @@
 /* From lowlevel_init.S */
 extern unsigned long fw_dtb_pointer;
 
+extern unsigned long reserve_memory;
+
 /* TODO(sjg@chromium.org): Move these to the msg.c file */
 struct msg_get_arm_mem {
 	struct bcm2835_mbox_hdr hdr;
@@ -222,6 +225,14 @@
 };
 
 struct mm_region *mem_map = bcm2837_mem_map;
+
+int dram_init_banksize(void)
+{
+	gd->bd->bi_dram[0].start = CONFIG_SYS_SDRAM_BASE + reserve_memory;
+	gd->bd->bi_dram[0].size = get_effective_memsize() - reserve_memory;
+
+	return (0);
+}
 #endif
 
 int dram_init(void)
@@ -357,6 +368,10 @@
 	set_board_info();
 #endif
 	set_serial_number();
+#ifdef CONFIG_ARM64
+	if (fw_dtb_pointer)
+		env_set_hex("fdt_addr_r", (ulong)fw_dtb_pointer);
+#endif
 
 	return 0;
 }
